<template>
  <div class="app-container">
    <div class="filter-container">
      <el-input v-model="query.title" :placeholder="$t('table.title')" style="width: 200px;" class="filter-item" @keyup.enter.native="handleFilter" />
      <el-button class="filter-item" type="primary" icon="el-icon-search" @click="handleFilter">
        {{ $t('table.search') }}
      </el-button>
      <el-button class="filter-item fa fa-plus" type="primary" @click="handleFilter">
        {{ $t('route.createTask') }}
      </el-button>
      <!--<el-button v-waves :loading="downloading" class="filter-item" type="primary" icon="el-icon-download" @click="handleDownload">-->
      <!--{{ $t('table.export') }}-->
      <!--</el-button>-->
    </div>
    <el-table v-loading="listLoading" :data="list" border fit highlight-current-row style="width: 100%">
      <el-table-column min-width="300px" align="center" :label="$t('row.title')">
        <template slot-scope="scope">
          <span>{{ scope.row.title }}</span>
        </template>
      </el-table-column>
      <el-table-column min-width="300px" align="center" :label="$t('row.explain')">
        <template slot-scope="scope">
          <span>{{ scope.row.explain }}</span>
        </template>
      </el-table-column>

      <el-table-column width="320px" align="center" :label="$t('row.user')">
        <template slot-scope="scope">
          <span>{{ scope.row.user }}</span>
        </template>
      </el-table-column>

      <el-table-column width="320px" align="center" :label="$t('row.address')">
        <template slot-scope="scope">
          <span>{{ scope.row.address }}</span>
        </template>
      </el-table-column>

      <el-table-column width="320px" align="center" :label="$t('row.createdBy')">
        <template slot-scope="scope">
          <span>{{ scope.row.user }}</span>
        </template>
      </el-table-column>

      <el-table-column align="center" :label="$t('row.operation')">
        <template slot-scope="scope">
          <span style="display: inline-block;width: 20px">
            <a class="fa fa-list pointer mr-1 ml-1" @click="handleAction(scope.row.id, scope.row.assignment_id)">&nbsp;</a>
          </span>
          <span style="display: inline-block;width: 20px">
            <a class="fa fa-remove pointer mr-1 ml-1" @click="handleRemove(scope.row.id, scope.row.assignment_id)">&nbsp;</a>
          </span>
          <span style="display: inline-block;width: 20px">
            <a class="fa fa-check pointer mr-1 ml-1" @click="handleAccept(scope.row.id, scope.row.assignment_id)">&nbsp;</a>
          </span>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total>0" :total="total" :page.sync="query.page" :limit.sync="query.limit" @pagination="getList" />

    <el-dialog :title="$t('user.actionFormVisible')" :visible.sync="actionFormVisible">
      <div v-loading="validateLoading" class="form-container">
        <b-form-input v-model="action.code" name="title" type="text" :placeholder="$t('user.code')" required />
        <div class="el-form-item el-form-item--medium">
          <div class="button-wrap">
            <label class="new-button" for="upload"> {{ $t('user.uploadFile') }}
              <input id="upload" type="file" @change="onImageChange">
            </label>
          </div>
        </div>
        <div class="el-form-item el-form-item--medium">
          <div class="button-wrap">
            <label class="new-button" for="upload2"> {{ $t('user.uploadFile') }}
              <input id="upload2" type="file" @change="onImageChange2">
            </label>
          </div>
        </div>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="actionFormVisible = false">
          {{ $t('table.cancel') }}
        </el-button>
        <el-button type="primary" @click="sendAction()">
          {{ $t('table.confirm') }}
        </el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import Pagination from '@/components/Pagination'; // Secondary package based on el-pagination
import Task from '@/api/task';
const taskResource = new Task('tasks');
import 'vue-select/src/scss/vue-select.scss';

export default {
  name: 'MyTasks',
  components: { Pagination },
  filters: {
    statusFilter(status) {
      const statusMap = {
        published: 'success',
        draft: 'info',
        deleted: 'danger',
      };
      return statusMap[status];
    },
  },
  data() {
    return {
      list: null,
      listTransfer: null,
      actionFormVisible: false,
      validateLoading: false,
      total: 0,
      listLoading: true,
      task: {},
      action: {},
      query: {
        page: 1,
        limit: 15,
        title: '',
        role: '',
      },
      options: [],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    async getList() {
      this.listLoading = true;
      const { result } = await taskResource.myTasks(this.query);
      this.list = result.rows;
      this.total = result.total;
      this.listLoading = false;
    },
    async handleRemove(id, assignment_id) {
      this.$confirm(this.$i18n.t(`dialog.isDelete`), this.$i18n.t(`dialog.confirm`), {
        confirmButtonText: this.$i18n.t(`dialog.confirm`),
        cancelButtonText: this.$i18n.t(`dialog.cancel`),
        type: 'warning',
      })
        .then(async() => {
          this.task.id = id;
          this.task.assignment_id = assignment_id;
          const { success } = await taskResource.removeAssignment(this.task);
          if (success === true) {
            this.getList();
          }
        })
      ;
    },
    async handleAccept(id, assignment_id) {
      this.$confirm(this.$i18n.t(`dialog.isAccept`), this.$i18n.t(`dialog.confirm`), {
        confirmButtonText: this.$i18n.t(`dialog.confirm`),
        cancelButtonText: this.$i18n.t(`dialog.cancel`),
        type: 'success',
      })
        .then(async() => {
          this.task.id = id;
          this.task.assignment_id = assignment_id;
          const { success } = await taskResource.acceptAssignment(this.task);
          if (success === true) {
            this.getList();
          }
        })
      ;
    },
    async handleAction(id, assignment_id) {
      this.action.id = id;
      this.action.assignment_id = assignment_id;
      this.actionFormVisible = true;
    },
    onImageChange(e) {
      const files = e.target.files || e.dataTransfer.files;
      if (!files.length){
        return;
      }
      this.createImage(files[0]);
    },
    createImage(file) {
      const reader = new FileReader();
      const vm = this;
      reader.onload = (e) => {
        vm.image = e.target.result;
      };
      reader.readAsDataURL(file);
    },
    onImageChange2(e) {
      const files = e.target.files || e.dataTransfer.files;
      if (!files.length){
        return;
      }
      this.createImage2(files[0]);
    },
    createImage2(file) {
      const reader = new FileReader();
      const vm = this;
      reader.onload = (e) => {
        vm.image2 = e.target.result;
      };
      reader.readAsDataURL(file);
    },
    sendAction() {
      this.action.image1 = this.image;
      this.action.image2 = this.image2;
      taskResource.sendAction(this.action);
      this.actionFormVisible = false;
      this.getList();
    },
    handleFilter() {
      this.query.page = 1;
      this.getList();
    },
    onSearch(search, loading) {
      fetch(
        '/api/searchUsers?q=' + search
      ).then(res => {
        res.json().then(json => (this.options = json.items));
        console.log(this.options);
        loading(false);
      });
    },
  },
};
</script>
